package errortest.app;


import org.ffd2.solar.pretty.PrettyPrinter;

import errortest.austen.peg.base.ExpressionPeer;
import errortest.austen.peg.base.StatementPeer.AssignmentPatternPeer;

public final class AssignmentStatement implements StatementHandler,AssignmentPatternPeer {
	private final String variable_;
	private final ExpressionBlock value_;
	public AssignmentStatement(String variable) {
		this.variable_ = variable;
		this.value_ = new ExpressionBlock();
	}
	public void end() { }
	public ExpressionPeer.Indirect getExpressionForValue() { return this.value_; }
	public void output(PrettyPrinter pp) {
		pp.print(this.variable_).print(" = ");
		this.value_.output(pp);
		pp.print(";");
	}

}