package errortest.app;


import org.ffd2.solar.pretty.PrettyPrinter;

import errortest.austen.peg.base.ExpressionPeer;
import errortest.austen.peg.base.StatementPeer.ExpressionPatternPeer;

public final class ExpressionStatement implements StatementHandler,ExpressionPatternPeer {
	private final ExpressionBlock expression_;
	public ExpressionStatement() {
		this.expression_ = new ExpressionBlock();
	}
	
	// ==== 
	public void end() { }
	public ExpressionPeer.Indirect getExpressionForE() { return this.expression_; }
	public void output(PrettyPrinter pp) { expression_.output(pp); pp.print(";"); }
}