package errortest.austen.packrat.impl;
import errortest.austen.packrat.library.*;
public final class FileReader implements ErrorTestPackrat.BaseReader {
	private final int rULE_INDEX_ = 2;
	private final ErrorTestPackrat basePackrat_;
	public FileReader(ErrorTestPackrat basePackrat) {
		basePackrat_ = basePackrat;
	}
	public final org.ffd2.austenx.runtime.PackratElement build(ErrorTestPackrat.Column c, org.ffd2.austenx.runtime.PackratElement oldElement) {
		org.ffd2.austenx.runtime.ResolvedPackratElement result = new org.ffd2.austenx.runtime.ResolvedPackratElement();
		int width = decodeFile(result, c, 0);
		if(width > 0) {
			result.setDetails(width, 0, 2);
			return oldElement.getImprovedByOrNull(result);
		}
		return null;
	}
	public final int decodeFile(org.ffd2.austenx.runtime.ResolvedPackratElement result, ErrorTestPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		int checkOffset = newOffset;
		result.mark();
		while(checkOffset >= 0) {
			checkOffset = zeroOrMoreSub(result, c, newOffset);
			if(checkOffset > newOffset) {
				newOffset = checkOffset;
				result.bumpLastMark();
			} else {
				result.undoToMark();
			}
		}
		return newOffset;
	}
	public final int zeroOrMoreSub(org.ffd2.austenx.runtime.ResolvedPackratElement result, ErrorTestPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 3).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(0, rule);
		return newOffset;
	}
}
