package errortest.austen.packrat.impl;
import errortest.austen.packrat.library.*;
import errortest.austen.lexi.tokens.*;
public final class FunctionDefReader implements ErrorTestPackrat.BaseReader {
	private final int rULE_INDEX_ = 3;
	private final ErrorTestPackrat basePackrat_;
	public FunctionDefReader(ErrorTestPackrat basePackrat) {
		basePackrat_ = basePackrat;
	}
	public final org.ffd2.austenx.runtime.PackratElement build(ErrorTestPackrat.Column c, org.ffd2.austenx.runtime.PackratElement oldElement) {
		org.ffd2.austenx.runtime.ResolvedPackratElement result = new org.ffd2.austenx.runtime.ResolvedPackratElement();
		int width = decodeFunctionDef(result, c, 0);
		if(width > 0) {
			result.setDetails(width, 0, 3);
			return oldElement.getImprovedByOrNull(result);
		}
		return null;
	}
	public final int decodeFunctionDef(org.ffd2.austenx.runtime.ResolvedPackratElement result, ErrorTestPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		ErrorsToken token = c.getColumnToken(newOffset);
		if(!token.isFUNCTION_KEYWORD()) {
			return -1;
		}
		newOffset++;
		result.addBaseArgument(0, token);
		ErrorsToken token_1 = c.getColumnToken(newOffset);
		if(!token_1.isID()) {
			return -1;
		}
		newOffset++;
		result.addBaseArgument(1, token_1);
		ErrorsToken token_2 = c.getColumnToken(newOffset);
		if(!token_2.isLEFT_ROUND()) {
			return -1;
		}
		newOffset++;
		c.setErrorHint("Expecting closing round bracket", newOffset);
		result.mark();
		int checkOffset = maybeSub(result, c, newOffset);
		if(checkOffset < 0) {
			result.undoToMark();
		} else {
			newOffset = checkOffset;
			result.removeLastMark();
		}
		result.mark();
		int checkOffset_1 = maybeSub_1(result, c, newOffset);
		if(checkOffset_1 < 0) {
			result.undoToMark();
		} else {
			newOffset = checkOffset_1;
			result.removeLastMark();
		}
		boolean found = false;
		result.mark();
		if(!found) {
			int checkOffset_2 = itemSub(result, c, newOffset);
			if(checkOffset_2 < 0) {
				result.undoToMark();
			} else {
				newOffset = checkOffset_2;
				result.removeLastMark();
				found = true;
			}
		}
		result.mark();
		if(!found) {
			int checkOffset_3 = itemSub_1(result, c, newOffset);
			if(checkOffset_3 < 0) {
				result.undoToMark();
			} else {
				newOffset = checkOffset_3;
				result.removeLastMark();
				found = true;
			}
		}
		if(!found) {
			return -1;
		}
		ErrorsToken token_3 = c.getColumnToken(newOffset);
		if(!token_3.isLEFT_CURLY()) {
			return -1;
		}
		newOffset++;
		int checkOffset_4 = newOffset;
		result.mark();
		while(checkOffset_4 >= 0) {
			checkOffset_4 = zeroOrMoreSub(result, c, newOffset);
			if(checkOffset_4 > newOffset) {
				newOffset = checkOffset_4;
				result.bumpLastMark();
			} else {
				result.undoToMark();
			}
		}
		result.mark();
		int checkOffset_5 = maybeSub_2(result, c, newOffset);
		if(checkOffset_5 < 0) {
			result.undoToMark();
		} else {
			newOffset = checkOffset_5;
			result.removeLastMark();
		}
		ErrorsToken token_4 = c.getColumnToken(newOffset);
		if(!token_4.isRIGHT_CURLY()) {
			return -1;
		}
		newOffset++;
		return newOffset;
	}
	public final int maybeSub(org.ffd2.austenx.runtime.ResolvedPackratElement result, ErrorTestPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		result.mark();
		int checkOffset = dividedPrimarySub(result, c, newOffset);
		if(checkOffset < 0) {
			result.undoToMark();
			return -1;
		} else {
			newOffset = checkOffset;
			result.bumpLastMark();
			while(checkOffset > 0) {
				checkOffset = dividedSecondarySub(result, c, newOffset);
				if(checkOffset >= 0) {
					checkOffset = dividedPrimarySub(result, c, checkOffset);
				}
				if(checkOffset >= 0) {
					newOffset = checkOffset;
					result.bumpLastMark();
				} else {
					result.undoToMark();
				}
			}
		}
		return newOffset;
	}
	public final int dividedPrimarySub(org.ffd2.austenx.runtime.ResolvedPackratElement result, ErrorTestPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		ErrorsToken token = c.getColumnToken(newOffset);
		if(!token.isID()) {
			return -1;
		}
		result.addSubToken(2, token);
		newOffset++;
		return newOffset;
	}
	public final int dividedSecondarySub(org.ffd2.austenx.runtime.ResolvedPackratElement result, ErrorTestPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		ErrorsToken token = c.getColumnToken(newOffset);
		if(!token.isCOMMA_SYMBOL()) {
			return -1;
		}
		newOffset++;
		return newOffset;
	}
	public final int maybeSub_1(org.ffd2.austenx.runtime.ResolvedPackratElement result, ErrorTestPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		result.addPositionMark(0, c.getColumnTokenOrLast(newOffset), false);
		result.mark();
		int checkOffset = oneOrMoreSub(result, c, newOffset);
		if(checkOffset < 0) {
			result.undoToMark();
			return -1;
		} else {
			newOffset = checkOffset;
			result.bumpLastMark();
			while(checkOffset >= 0) {
				checkOffset = oneOrMoreSub(result, c, newOffset);
				if(checkOffset > newOffset) {
					newOffset = checkOffset;
					result.bumpLastMark();
				} else {
					result.undoToMark();
				}
			}
		}
		return newOffset;
	}
	public final int oneOrMoreSub(org.ffd2.austenx.runtime.ResolvedPackratElement result, ErrorTestPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		result.mark();
		int checkOffset = notFollowedBySub(result, c, newOffset);
		result.undoToMark();
		if(checkOffset > 0) {
			return -1;
		}
		if(!c.isColumnTokenAt(newOffset)) {
			return -1;
		}
		newOffset++;
		return newOffset;
	}
	public final int notFollowedBySub(org.ffd2.austenx.runtime.ResolvedPackratElement result, ErrorTestPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		ErrorsToken token = c.getColumnToken(newOffset);
		if(!token.isRIGHT_ROUND()) {
			return -1;
		}
		newOffset++;
		return newOffset;
	}
	public final int itemSub(org.ffd2.austenx.runtime.ResolvedPackratElement result, ErrorTestPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		ErrorsToken token = c.getColumnToken(newOffset);
		if(!token.isRIGHT_ROUND()) {
			return -1;
		}
		newOffset++;
		return newOffset;
	}
	public final int itemSub_1(org.ffd2.austenx.runtime.ResolvedPackratElement result, ErrorTestPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		result.addPositionMark(1, c.getColumnTokenOrLast(newOffset), false);
		return newOffset;
	}
	public final int zeroOrMoreSub(org.ffd2.austenx.runtime.ResolvedPackratElement result, ErrorTestPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 1).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(0, rule);
		return newOffset;
	}
	public final int maybeSub_2(org.ffd2.austenx.runtime.ResolvedPackratElement result, ErrorTestPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		result.addPositionMark(2, c.getColumnTokenOrLast(newOffset), false);
		result.mark();
		int checkOffset = oneOrMoreSub_1(result, c, newOffset);
		if(checkOffset < 0) {
			result.undoToMark();
			return -1;
		} else {
			newOffset = checkOffset;
			result.bumpLastMark();
			while(checkOffset >= 0) {
				checkOffset = oneOrMoreSub_1(result, c, newOffset);
				if(checkOffset > newOffset) {
					newOffset = checkOffset;
					result.bumpLastMark();
				} else {
					result.undoToMark();
				}
			}
		}
		return newOffset;
	}
	public final int oneOrMoreSub_1(org.ffd2.austenx.runtime.ResolvedPackratElement result, ErrorTestPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		result.mark();
		int checkOffset = notFollowedBySub_1(result, c, newOffset);
		result.undoToMark();
		if(checkOffset > 0) {
			return -1;
		}
		if(!c.isColumnTokenAt(newOffset)) {
			return -1;
		}
		newOffset++;
		return newOffset;
	}
	public final int notFollowedBySub_1(org.ffd2.austenx.runtime.ResolvedPackratElement result, ErrorTestPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		ErrorsToken token = c.getColumnToken(newOffset);
		if(!token.isRIGHT_CURLY()) {
			return -1;
		}
		newOffset++;
		return newOffset;
	}
}
