package errortest.austen.peg.base;
public final class ExpressionPeer {
	public static interface Indirect {
		public ExpressionPeer.AdditionPatternPeer createAddition() ;
		public ExpressionPeer.SubtractionPatternPeer createSubtraction() ;
		public ExpressionPeer.MultiplicationPatternPeer createMultiplication() ;
		public ExpressionPeer.DivisionPatternPeer createDivision() ;
		public ExpressionPeer.FunctionPatternPeer createFunction(java.lang.String name) ;
		public void createVariable(java.lang.String name) ;
		public ExpressionPeer.PrimitivePatternPeer createPrimitive() ;
	}
	public static interface AdditionPatternPeer {
		public void end() ;
		public ExpressionPeer.Indirect getExpressionForLeft() ;
		public ExpressionPeer.Indirect getExpressionForRight() ;
	}
	public static interface SubtractionPatternPeer {
		public void end() ;
		public ExpressionPeer.Indirect getExpressionForLeft() ;
		public ExpressionPeer.Indirect getExpressionForRight() ;
	}
	public static interface MultiplicationPatternPeer {
		public void end() ;
		public ExpressionPeer.Indirect getExpressionForLeft() ;
		public ExpressionPeer.Indirect getExpressionForRight() ;
	}
	public static interface DivisionPatternPeer {
		public void end() ;
		public ExpressionPeer.Indirect getExpressionForLeft() ;
		public ExpressionPeer.Indirect getExpressionForRight() ;
	}
	public static interface FunctionPatternPeer {
		public void end() ;
		public ExpressionPeer.Indirect getExpressionForValue() ;
	}
	public static interface PrimitivePatternPeer {
		public void end() ;
		public void addNumber(int value) ;
		public void addBool(boolean value) ;
		public void addString(java.lang.String value) ;
	}
}
