package errortest.austen.peg.base;
public final class StatementPeer {
	public static interface Indirect {
		public StatementPeer.AssignmentPatternPeer createAssignment(java.lang.String variable) ;
		public StatementPeer.BlockPatternPeer createBlock() ;
		public StatementPeer.IfPatternPeer createIf(int keywordLine, int keywordCharacter) ;
		public StatementPeer.ExpressionPatternPeer createExpression() ;
		public void createError(org.ffd2.austenx.runtime.BaseToken startTokenMarkToken, int lastSemicolonLine, int lastSemicolonCharacter) ;
	}
	public static interface AssignmentPatternPeer {
		public void end() ;
		public ExpressionPeer.Indirect getExpressionForValue() ;
	}
	public static interface BlockPatternPeer {
		public void end() ;
		public StatementPeer.Indirect getStatementForStatement() ;
	}
	public static interface IfPatternPeer {
		public void end() ;
		public ExpressionPeer.Indirect getExpressionForConditional() ;
		public StatementPeer.Indirect getStatementForTrueStatement() ;
		public StatementPeer.Indirect getStatementForFalseStatement() ;
	}
	public static interface ExpressionPatternPeer {
		public void end() ;
		public ExpressionPeer.Indirect getExpressionForE() ;
	}
}
