package indent.austen.packrat.impl;
import indent.austen.packrat.library.*;
import indent.austen.user.*;
import indent.austen.lexi.tokens.*;
public final class ClassElementReader implements IndentTestPackrat.BaseReader {
	private final int rULE_INDEX_ = 5;
	private final IndentTestPackrat basePackrat_;
	public ClassElementReader(IndentTestPackrat basePackrat) {
		basePackrat_ = basePackrat;
	}
	public final org.ffd2.austenx.runtime.PackratElement build(IndentTestPackrat.Column c, org.ffd2.austenx.runtime.PackratElement oldElement) {
		org.ffd2.austenx.runtime.ResolvedPackratElement result = new org.ffd2.austenx.runtime.ResolvedPackratElement();
		int width = 0;
		result.mark();
		width = decodeFunctionDefForClassElement(result, c, 0);
		if(width > 0) {
			result.removeLastMark();
			result.setDetails(width, 0, 5);
			return oldElement.getImprovedByOrNull(result);
		} else {
			result.undoToMark();
		}
		return null;
	}
	public final int decodeFunctionDefForClassElement(org.ffd2.austenx.runtime.ResolvedPackratElement result, IndentTestPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		c.indentBaseValue__1_ = 0;
		c.currentIndentValue__2_ = 0;
		IndentTrackerUser baseClass = basePackrat_.trackerValue_;
		int lineInt;
		lineInt = c.getCurrentLineNumber(newOffset);
		c.indentBaseValue__1_ = baseClass.getIndent(lineInt);
		IndentToken token = c.getColumnToken(newOffset);
		if(!token.isFUNCTION_KEYWORD()) {
			return -1;
		}
		newOffset++;
		result.addBaseArgument(0, token);
		IndentToken token_1 = c.getColumnToken(newOffset);
		if(!token_1.isID()) {
			return -1;
		}
		newOffset++;
		result.addBaseArgument(1, token_1);
		IndentToken token_2 = c.getColumnToken(newOffset);
		if(!token_2.isLEFT_ROUND()) {
			return -1;
		}
		newOffset++;
		result.mark();
		int checkOffset = maybeSub(result, c, newOffset);
		if(checkOffset < 0) {
			result.undoToMark();
		} else {
			newOffset = checkOffset;
			result.removeLastMark();
		}
		IndentToken token_3 = c.getColumnToken(newOffset);
		if(!token_3.isRIGHT_ROUND()) {
			return -1;
		}
		newOffset++;
		int checkOffset_1 = newOffset;
		result.mark();
		while(checkOffset_1 >= 0) {
			checkOffset_1 = zeroOrMoreSub(result, c, newOffset);
			if(checkOffset_1 > newOffset) {
				newOffset = checkOffset_1;
				result.bumpLastMark();
			} else {
				result.undoToMark();
			}
		}
		return newOffset;
	}
	public final int maybeSub(org.ffd2.austenx.runtime.ResolvedPackratElement result, IndentTestPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		result.mark();
		int checkOffset = dividedPrimarySub(result, c, newOffset);
		if(checkOffset < 0) {
			result.undoToMark();
			return -1;
		} else {
			newOffset = checkOffset;
			result.bumpLastMark();
			while(checkOffset > 0) {
				checkOffset = dividedSecondarySub(result, c, newOffset);
				if(checkOffset >= 0) {
					checkOffset = dividedPrimarySub(result, c, checkOffset);
				}
				if(checkOffset >= 0) {
					newOffset = checkOffset;
					result.bumpLastMark();
				} else {
					result.undoToMark();
				}
			}
		}
		return newOffset;
	}
	public final int dividedPrimarySub(org.ffd2.austenx.runtime.ResolvedPackratElement result, IndentTestPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		IndentToken token = c.getColumnToken(newOffset);
		if(!token.isID()) {
			return -1;
		}
		result.addSubToken(2, token);
		newOffset++;
		return newOffset;
	}
	public final int dividedSecondarySub(org.ffd2.austenx.runtime.ResolvedPackratElement result, IndentTestPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		IndentToken token = c.getColumnToken(newOffset);
		if(!token.isCOMMA_SYMBOL()) {
			return -1;
		}
		newOffset++;
		return newOffset;
	}
	public final int zeroOrMoreSub(org.ffd2.austenx.runtime.ResolvedPackratElement result, IndentTestPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		IndentTrackerUser baseClass = basePackrat_.trackerValue_;
		int lineInt;
		lineInt = c.getCurrentLineNumber(newOffset);
		c.currentIndentValue__2_ = baseClass.getIndent(lineInt);
		boolean passQuery;
		int left;
		int right;
		left = c.indentBaseValue__1_;
		right = c.currentIndentValue__2_;
		passQuery = left < right;
		if(!passQuery) {
			return -1;
		}
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 1).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(0, rule);
		return newOffset;
	}
}
