package errortest.austen.packrat.impl;
import errortest.austen.peg.base.*;
public final class AllDecodersErrorTest {
	public static final class AdditionDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final ExpressionPeer.AdditionPatternPeer peer_;
		public AdditionDecoder(ExpressionPeer.AdditionPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				int type = element.getType();
				if(type == 0) {
					ExpressionPeer.Indirect indirect = peer_.getExpressionForLeft();
					if(indirect != null) {
						ExpressionPeer.AdditionPatternPeer child = indirect.createAddition();
						if(child != null) {
							element.updateConstruction(new AllDecodersErrorTest.AdditionDecoder(child));
							child.end();
						}
					}
				}
				if(type == 1) {
					ExpressionPeer.Indirect indirect_1 = peer_.getExpressionForLeft();
					if(indirect_1 != null) {
						ExpressionPeer.SubtractionPatternPeer child_1 = indirect_1.createSubtraction();
						if(child_1 != null) {
							element.updateConstruction(new AllDecodersErrorTest.SubtractionDecoder(child_1));
							child_1.end();
						}
					}
				}
				if(type == 2) {
					ExpressionPeer.Indirect indirect_2 = peer_.getExpressionForLeft();
					if(indirect_2 != null) {
						ExpressionPeer.MultiplicationPatternPeer child_2 = indirect_2.createMultiplication();
						if(child_2 != null) {
							element.updateConstruction(new AllDecodersErrorTest.MultiplicationDecoder(child_2));
							child_2.end();
						}
					}
				}
				if(type == 3) {
					ExpressionPeer.Indirect indirect_3 = peer_.getExpressionForLeft();
					if(indirect_3 != null) {
						ExpressionPeer.DivisionPatternPeer child_3 = indirect_3.createDivision();
						if(child_3 != null) {
							element.updateConstruction(new AllDecodersErrorTest.DivisionDecoder(child_3));
							child_3.end();
						}
					}
				}
				if(type == 4) {
					ExpressionPeer.Indirect indirect_4 = peer_.getExpressionForLeft();
					if(indirect_4 != null) {
						org.ffd2.austenx.runtime.BaseToken nameToken = element.getBaseArgumentToken(0);
						ExpressionPeer.FunctionPatternPeer child_4 = indirect_4.createFunction(nameToken.getStringValue());
						if(child_4 != null) {
							element.updateConstruction(new AllDecodersErrorTest.FunctionDecoder(child_4));
							child_4.end();
						}
					}
				}
				if(type == 5) {
					ExpressionPeer.Indirect indirect_5 = peer_.getExpressionForLeft();
					if(indirect_5 != null) {
						org.ffd2.austenx.runtime.BaseToken nameToken_1 = element.getBaseArgumentToken(0);
						indirect_5.createVariable(nameToken_1.getStringValue());
					}
				}
				if(type == 6) {
					ExpressionPeer.Indirect indirect_6 = peer_.getExpressionForLeft();
					if(indirect_6 != null) {
						ExpressionPeer.PrimitivePatternPeer child_5 = indirect_6.createPrimitive();
						if(child_5 != null) {
							element.updateConstruction(new AllDecodersErrorTest.PrimitiveDecoder(child_5));
							child_5.end();
						}
					}
				}
			}
			if(index == 1) {
				int type_1 = element.getType();
				if(type_1 == 0) {
					ExpressionPeer.Indirect indirect_7 = peer_.getExpressionForRight();
					if(indirect_7 != null) {
						ExpressionPeer.AdditionPatternPeer child_6 = indirect_7.createAddition();
						if(child_6 != null) {
							element.updateConstruction(new AllDecodersErrorTest.AdditionDecoder(child_6));
							child_6.end();
						}
					}
				}
				if(type_1 == 1) {
					ExpressionPeer.Indirect indirect_8 = peer_.getExpressionForRight();
					if(indirect_8 != null) {
						ExpressionPeer.SubtractionPatternPeer child_7 = indirect_8.createSubtraction();
						if(child_7 != null) {
							element.updateConstruction(new AllDecodersErrorTest.SubtractionDecoder(child_7));
							child_7.end();
						}
					}
				}
				if(type_1 == 2) {
					ExpressionPeer.Indirect indirect_9 = peer_.getExpressionForRight();
					if(indirect_9 != null) {
						ExpressionPeer.MultiplicationPatternPeer child_8 = indirect_9.createMultiplication();
						if(child_8 != null) {
							element.updateConstruction(new AllDecodersErrorTest.MultiplicationDecoder(child_8));
							child_8.end();
						}
					}
				}
				if(type_1 == 3) {
					ExpressionPeer.Indirect indirect_10 = peer_.getExpressionForRight();
					if(indirect_10 != null) {
						ExpressionPeer.DivisionPatternPeer child_9 = indirect_10.createDivision();
						if(child_9 != null) {
							element.updateConstruction(new AllDecodersErrorTest.DivisionDecoder(child_9));
							child_9.end();
						}
					}
				}
				if(type_1 == 4) {
					ExpressionPeer.Indirect indirect_11 = peer_.getExpressionForRight();
					if(indirect_11 != null) {
						org.ffd2.austenx.runtime.BaseToken nameToken_2 = element.getBaseArgumentToken(0);
						ExpressionPeer.FunctionPatternPeer child_10 = indirect_11.createFunction(nameToken_2.getStringValue());
						if(child_10 != null) {
							element.updateConstruction(new AllDecodersErrorTest.FunctionDecoder(child_10));
							child_10.end();
						}
					}
				}
				if(type_1 == 5) {
					ExpressionPeer.Indirect indirect_12 = peer_.getExpressionForRight();
					if(indirect_12 != null) {
						org.ffd2.austenx.runtime.BaseToken nameToken_3 = element.getBaseArgumentToken(0);
						indirect_12.createVariable(nameToken_3.getStringValue());
					}
				}
				if(type_1 == 6) {
					ExpressionPeer.Indirect indirect_13 = peer_.getExpressionForRight();
					if(indirect_13 != null) {
						ExpressionPeer.PrimitivePatternPeer child_11 = indirect_13.createPrimitive();
						if(child_11 != null) {
							element.updateConstruction(new AllDecodersErrorTest.PrimitiveDecoder(child_11));
							child_11.end();
						}
					}
				}
			}
		}
	}
	public static final class SubtractionDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final ExpressionPeer.SubtractionPatternPeer peer_;
		public SubtractionDecoder(ExpressionPeer.SubtractionPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				int type = element.getType();
				if(type == 0) {
					ExpressionPeer.Indirect indirect = peer_.getExpressionForLeft();
					if(indirect != null) {
						ExpressionPeer.AdditionPatternPeer child = indirect.createAddition();
						if(child != null) {
							element.updateConstruction(new AllDecodersErrorTest.AdditionDecoder(child));
							child.end();
						}
					}
				}
				if(type == 1) {
					ExpressionPeer.Indirect indirect_1 = peer_.getExpressionForLeft();
					if(indirect_1 != null) {
						ExpressionPeer.SubtractionPatternPeer child_1 = indirect_1.createSubtraction();
						if(child_1 != null) {
							element.updateConstruction(new AllDecodersErrorTest.SubtractionDecoder(child_1));
							child_1.end();
						}
					}
				}
				if(type == 2) {
					ExpressionPeer.Indirect indirect_2 = peer_.getExpressionForLeft();
					if(indirect_2 != null) {
						ExpressionPeer.MultiplicationPatternPeer child_2 = indirect_2.createMultiplication();
						if(child_2 != null) {
							element.updateConstruction(new AllDecodersErrorTest.MultiplicationDecoder(child_2));
							child_2.end();
						}
					}
				}
				if(type == 3) {
					ExpressionPeer.Indirect indirect_3 = peer_.getExpressionForLeft();
					if(indirect_3 != null) {
						ExpressionPeer.DivisionPatternPeer child_3 = indirect_3.createDivision();
						if(child_3 != null) {
							element.updateConstruction(new AllDecodersErrorTest.DivisionDecoder(child_3));
							child_3.end();
						}
					}
				}
				if(type == 4) {
					ExpressionPeer.Indirect indirect_4 = peer_.getExpressionForLeft();
					if(indirect_4 != null) {
						org.ffd2.austenx.runtime.BaseToken nameToken = element.getBaseArgumentToken(0);
						ExpressionPeer.FunctionPatternPeer child_4 = indirect_4.createFunction(nameToken.getStringValue());
						if(child_4 != null) {
							element.updateConstruction(new AllDecodersErrorTest.FunctionDecoder(child_4));
							child_4.end();
						}
					}
				}
				if(type == 5) {
					ExpressionPeer.Indirect indirect_5 = peer_.getExpressionForLeft();
					if(indirect_5 != null) {
						org.ffd2.austenx.runtime.BaseToken nameToken_1 = element.getBaseArgumentToken(0);
						indirect_5.createVariable(nameToken_1.getStringValue());
					}
				}
				if(type == 6) {
					ExpressionPeer.Indirect indirect_6 = peer_.getExpressionForLeft();
					if(indirect_6 != null) {
						ExpressionPeer.PrimitivePatternPeer child_5 = indirect_6.createPrimitive();
						if(child_5 != null) {
							element.updateConstruction(new AllDecodersErrorTest.PrimitiveDecoder(child_5));
							child_5.end();
						}
					}
				}
			}
			if(index == 1) {
				int type_1 = element.getType();
				if(type_1 == 0) {
					ExpressionPeer.Indirect indirect_7 = peer_.getExpressionForRight();
					if(indirect_7 != null) {
						ExpressionPeer.AdditionPatternPeer child_6 = indirect_7.createAddition();
						if(child_6 != null) {
							element.updateConstruction(new AllDecodersErrorTest.AdditionDecoder(child_6));
							child_6.end();
						}
					}
				}
				if(type_1 == 1) {
					ExpressionPeer.Indirect indirect_8 = peer_.getExpressionForRight();
					if(indirect_8 != null) {
						ExpressionPeer.SubtractionPatternPeer child_7 = indirect_8.createSubtraction();
						if(child_7 != null) {
							element.updateConstruction(new AllDecodersErrorTest.SubtractionDecoder(child_7));
							child_7.end();
						}
					}
				}
				if(type_1 == 2) {
					ExpressionPeer.Indirect indirect_9 = peer_.getExpressionForRight();
					if(indirect_9 != null) {
						ExpressionPeer.MultiplicationPatternPeer child_8 = indirect_9.createMultiplication();
						if(child_8 != null) {
							element.updateConstruction(new AllDecodersErrorTest.MultiplicationDecoder(child_8));
							child_8.end();
						}
					}
				}
				if(type_1 == 3) {
					ExpressionPeer.Indirect indirect_10 = peer_.getExpressionForRight();
					if(indirect_10 != null) {
						ExpressionPeer.DivisionPatternPeer child_9 = indirect_10.createDivision();
						if(child_9 != null) {
							element.updateConstruction(new AllDecodersErrorTest.DivisionDecoder(child_9));
							child_9.end();
						}
					}
				}
				if(type_1 == 4) {
					ExpressionPeer.Indirect indirect_11 = peer_.getExpressionForRight();
					if(indirect_11 != null) {
						org.ffd2.austenx.runtime.BaseToken nameToken_2 = element.getBaseArgumentToken(0);
						ExpressionPeer.FunctionPatternPeer child_10 = indirect_11.createFunction(nameToken_2.getStringValue());
						if(child_10 != null) {
							element.updateConstruction(new AllDecodersErrorTest.FunctionDecoder(child_10));
							child_10.end();
						}
					}
				}
				if(type_1 == 5) {
					ExpressionPeer.Indirect indirect_12 = peer_.getExpressionForRight();
					if(indirect_12 != null) {
						org.ffd2.austenx.runtime.BaseToken nameToken_3 = element.getBaseArgumentToken(0);
						indirect_12.createVariable(nameToken_3.getStringValue());
					}
				}
				if(type_1 == 6) {
					ExpressionPeer.Indirect indirect_13 = peer_.getExpressionForRight();
					if(indirect_13 != null) {
						ExpressionPeer.PrimitivePatternPeer child_11 = indirect_13.createPrimitive();
						if(child_11 != null) {
							element.updateConstruction(new AllDecodersErrorTest.PrimitiveDecoder(child_11));
							child_11.end();
						}
					}
				}
			}
		}
	}
	public static final class MultiplicationDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final ExpressionPeer.MultiplicationPatternPeer peer_;
		public MultiplicationDecoder(ExpressionPeer.MultiplicationPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				int type = element.getType();
				if(type == 0) {
					ExpressionPeer.Indirect indirect = peer_.getExpressionForLeft();
					if(indirect != null) {
						ExpressionPeer.AdditionPatternPeer child = indirect.createAddition();
						if(child != null) {
							element.updateConstruction(new AllDecodersErrorTest.AdditionDecoder(child));
							child.end();
						}
					}
				}
				if(type == 1) {
					ExpressionPeer.Indirect indirect_1 = peer_.getExpressionForLeft();
					if(indirect_1 != null) {
						ExpressionPeer.SubtractionPatternPeer child_1 = indirect_1.createSubtraction();
						if(child_1 != null) {
							element.updateConstruction(new AllDecodersErrorTest.SubtractionDecoder(child_1));
							child_1.end();
						}
					}
				}
				if(type == 2) {
					ExpressionPeer.Indirect indirect_2 = peer_.getExpressionForLeft();
					if(indirect_2 != null) {
						ExpressionPeer.MultiplicationPatternPeer child_2 = indirect_2.createMultiplication();
						if(child_2 != null) {
							element.updateConstruction(new AllDecodersErrorTest.MultiplicationDecoder(child_2));
							child_2.end();
						}
					}
				}
				if(type == 3) {
					ExpressionPeer.Indirect indirect_3 = peer_.getExpressionForLeft();
					if(indirect_3 != null) {
						ExpressionPeer.DivisionPatternPeer child_3 = indirect_3.createDivision();
						if(child_3 != null) {
							element.updateConstruction(new AllDecodersErrorTest.DivisionDecoder(child_3));
							child_3.end();
						}
					}
				}
				if(type == 4) {
					ExpressionPeer.Indirect indirect_4 = peer_.getExpressionForLeft();
					if(indirect_4 != null) {
						org.ffd2.austenx.runtime.BaseToken nameToken = element.getBaseArgumentToken(0);
						ExpressionPeer.FunctionPatternPeer child_4 = indirect_4.createFunction(nameToken.getStringValue());
						if(child_4 != null) {
							element.updateConstruction(new AllDecodersErrorTest.FunctionDecoder(child_4));
							child_4.end();
						}
					}
				}
				if(type == 5) {
					ExpressionPeer.Indirect indirect_5 = peer_.getExpressionForLeft();
					if(indirect_5 != null) {
						org.ffd2.austenx.runtime.BaseToken nameToken_1 = element.getBaseArgumentToken(0);
						indirect_5.createVariable(nameToken_1.getStringValue());
					}
				}
				if(type == 6) {
					ExpressionPeer.Indirect indirect_6 = peer_.getExpressionForLeft();
					if(indirect_6 != null) {
						ExpressionPeer.PrimitivePatternPeer child_5 = indirect_6.createPrimitive();
						if(child_5 != null) {
							element.updateConstruction(new AllDecodersErrorTest.PrimitiveDecoder(child_5));
							child_5.end();
						}
					}
				}
			}
			if(index == 1) {
				int type_1 = element.getType();
				if(type_1 == 0) {
					ExpressionPeer.Indirect indirect_7 = peer_.getExpressionForRight();
					if(indirect_7 != null) {
						ExpressionPeer.AdditionPatternPeer child_6 = indirect_7.createAddition();
						if(child_6 != null) {
							element.updateConstruction(new AllDecodersErrorTest.AdditionDecoder(child_6));
							child_6.end();
						}
					}
				}
				if(type_1 == 1) {
					ExpressionPeer.Indirect indirect_8 = peer_.getExpressionForRight();
					if(indirect_8 != null) {
						ExpressionPeer.SubtractionPatternPeer child_7 = indirect_8.createSubtraction();
						if(child_7 != null) {
							element.updateConstruction(new AllDecodersErrorTest.SubtractionDecoder(child_7));
							child_7.end();
						}
					}
				}
				if(type_1 == 2) {
					ExpressionPeer.Indirect indirect_9 = peer_.getExpressionForRight();
					if(indirect_9 != null) {
						ExpressionPeer.MultiplicationPatternPeer child_8 = indirect_9.createMultiplication();
						if(child_8 != null) {
							element.updateConstruction(new AllDecodersErrorTest.MultiplicationDecoder(child_8));
							child_8.end();
						}
					}
				}
				if(type_1 == 3) {
					ExpressionPeer.Indirect indirect_10 = peer_.getExpressionForRight();
					if(indirect_10 != null) {
						ExpressionPeer.DivisionPatternPeer child_9 = indirect_10.createDivision();
						if(child_9 != null) {
							element.updateConstruction(new AllDecodersErrorTest.DivisionDecoder(child_9));
							child_9.end();
						}
					}
				}
				if(type_1 == 4) {
					ExpressionPeer.Indirect indirect_11 = peer_.getExpressionForRight();
					if(indirect_11 != null) {
						org.ffd2.austenx.runtime.BaseToken nameToken_2 = element.getBaseArgumentToken(0);
						ExpressionPeer.FunctionPatternPeer child_10 = indirect_11.createFunction(nameToken_2.getStringValue());
						if(child_10 != null) {
							element.updateConstruction(new AllDecodersErrorTest.FunctionDecoder(child_10));
							child_10.end();
						}
					}
				}
				if(type_1 == 5) {
					ExpressionPeer.Indirect indirect_12 = peer_.getExpressionForRight();
					if(indirect_12 != null) {
						org.ffd2.austenx.runtime.BaseToken nameToken_3 = element.getBaseArgumentToken(0);
						indirect_12.createVariable(nameToken_3.getStringValue());
					}
				}
				if(type_1 == 6) {
					ExpressionPeer.Indirect indirect_13 = peer_.getExpressionForRight();
					if(indirect_13 != null) {
						ExpressionPeer.PrimitivePatternPeer child_11 = indirect_13.createPrimitive();
						if(child_11 != null) {
							element.updateConstruction(new AllDecodersErrorTest.PrimitiveDecoder(child_11));
							child_11.end();
						}
					}
				}
			}
		}
	}
	public static final class DivisionDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final ExpressionPeer.DivisionPatternPeer peer_;
		public DivisionDecoder(ExpressionPeer.DivisionPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				int type = element.getType();
				if(type == 0) {
					ExpressionPeer.Indirect indirect = peer_.getExpressionForLeft();
					if(indirect != null) {
						ExpressionPeer.AdditionPatternPeer child = indirect.createAddition();
						if(child != null) {
							element.updateConstruction(new AllDecodersErrorTest.AdditionDecoder(child));
							child.end();
						}
					}
				}
				if(type == 1) {
					ExpressionPeer.Indirect indirect_1 = peer_.getExpressionForLeft();
					if(indirect_1 != null) {
						ExpressionPeer.SubtractionPatternPeer child_1 = indirect_1.createSubtraction();
						if(child_1 != null) {
							element.updateConstruction(new AllDecodersErrorTest.SubtractionDecoder(child_1));
							child_1.end();
						}
					}
				}
				if(type == 2) {
					ExpressionPeer.Indirect indirect_2 = peer_.getExpressionForLeft();
					if(indirect_2 != null) {
						ExpressionPeer.MultiplicationPatternPeer child_2 = indirect_2.createMultiplication();
						if(child_2 != null) {
							element.updateConstruction(new AllDecodersErrorTest.MultiplicationDecoder(child_2));
							child_2.end();
						}
					}
				}
				if(type == 3) {
					ExpressionPeer.Indirect indirect_3 = peer_.getExpressionForLeft();
					if(indirect_3 != null) {
						ExpressionPeer.DivisionPatternPeer child_3 = indirect_3.createDivision();
						if(child_3 != null) {
							element.updateConstruction(new AllDecodersErrorTest.DivisionDecoder(child_3));
							child_3.end();
						}
					}
				}
				if(type == 4) {
					ExpressionPeer.Indirect indirect_4 = peer_.getExpressionForLeft();
					if(indirect_4 != null) {
						org.ffd2.austenx.runtime.BaseToken nameToken = element.getBaseArgumentToken(0);
						ExpressionPeer.FunctionPatternPeer child_4 = indirect_4.createFunction(nameToken.getStringValue());
						if(child_4 != null) {
							element.updateConstruction(new AllDecodersErrorTest.FunctionDecoder(child_4));
							child_4.end();
						}
					}
				}
				if(type == 5) {
					ExpressionPeer.Indirect indirect_5 = peer_.getExpressionForLeft();
					if(indirect_5 != null) {
						org.ffd2.austenx.runtime.BaseToken nameToken_1 = element.getBaseArgumentToken(0);
						indirect_5.createVariable(nameToken_1.getStringValue());
					}
				}
				if(type == 6) {
					ExpressionPeer.Indirect indirect_6 = peer_.getExpressionForLeft();
					if(indirect_6 != null) {
						ExpressionPeer.PrimitivePatternPeer child_5 = indirect_6.createPrimitive();
						if(child_5 != null) {
							element.updateConstruction(new AllDecodersErrorTest.PrimitiveDecoder(child_5));
							child_5.end();
						}
					}
				}
			}
			if(index == 1) {
				int type_1 = element.getType();
				if(type_1 == 0) {
					ExpressionPeer.Indirect indirect_7 = peer_.getExpressionForRight();
					if(indirect_7 != null) {
						ExpressionPeer.AdditionPatternPeer child_6 = indirect_7.createAddition();
						if(child_6 != null) {
							element.updateConstruction(new AllDecodersErrorTest.AdditionDecoder(child_6));
							child_6.end();
						}
					}
				}
				if(type_1 == 1) {
					ExpressionPeer.Indirect indirect_8 = peer_.getExpressionForRight();
					if(indirect_8 != null) {
						ExpressionPeer.SubtractionPatternPeer child_7 = indirect_8.createSubtraction();
						if(child_7 != null) {
							element.updateConstruction(new AllDecodersErrorTest.SubtractionDecoder(child_7));
							child_7.end();
						}
					}
				}
				if(type_1 == 2) {
					ExpressionPeer.Indirect indirect_9 = peer_.getExpressionForRight();
					if(indirect_9 != null) {
						ExpressionPeer.MultiplicationPatternPeer child_8 = indirect_9.createMultiplication();
						if(child_8 != null) {
							element.updateConstruction(new AllDecodersErrorTest.MultiplicationDecoder(child_8));
							child_8.end();
						}
					}
				}
				if(type_1 == 3) {
					ExpressionPeer.Indirect indirect_10 = peer_.getExpressionForRight();
					if(indirect_10 != null) {
						ExpressionPeer.DivisionPatternPeer child_9 = indirect_10.createDivision();
						if(child_9 != null) {
							element.updateConstruction(new AllDecodersErrorTest.DivisionDecoder(child_9));
							child_9.end();
						}
					}
				}
				if(type_1 == 4) {
					ExpressionPeer.Indirect indirect_11 = peer_.getExpressionForRight();
					if(indirect_11 != null) {
						org.ffd2.austenx.runtime.BaseToken nameToken_2 = element.getBaseArgumentToken(0);
						ExpressionPeer.FunctionPatternPeer child_10 = indirect_11.createFunction(nameToken_2.getStringValue());
						if(child_10 != null) {
							element.updateConstruction(new AllDecodersErrorTest.FunctionDecoder(child_10));
							child_10.end();
						}
					}
				}
				if(type_1 == 5) {
					ExpressionPeer.Indirect indirect_12 = peer_.getExpressionForRight();
					if(indirect_12 != null) {
						org.ffd2.austenx.runtime.BaseToken nameToken_3 = element.getBaseArgumentToken(0);
						indirect_12.createVariable(nameToken_3.getStringValue());
					}
				}
				if(type_1 == 6) {
					ExpressionPeer.Indirect indirect_13 = peer_.getExpressionForRight();
					if(indirect_13 != null) {
						ExpressionPeer.PrimitivePatternPeer child_11 = indirect_13.createPrimitive();
						if(child_11 != null) {
							element.updateConstruction(new AllDecodersErrorTest.PrimitiveDecoder(child_11));
							child_11.end();
						}
					}
				}
			}
		}
	}
	public static final class FunctionDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final ExpressionPeer.FunctionPatternPeer peer_;
		public FunctionDecoder(ExpressionPeer.FunctionPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				int type = element.getType();
				if(type == 0) {
					ExpressionPeer.Indirect indirect = peer_.getExpressionForValue();
					if(indirect != null) {
						ExpressionPeer.AdditionPatternPeer child = indirect.createAddition();
						if(child != null) {
							element.updateConstruction(new AllDecodersErrorTest.AdditionDecoder(child));
							child.end();
						}
					}
				}
				if(type == 1) {
					ExpressionPeer.Indirect indirect_1 = peer_.getExpressionForValue();
					if(indirect_1 != null) {
						ExpressionPeer.SubtractionPatternPeer child_1 = indirect_1.createSubtraction();
						if(child_1 != null) {
							element.updateConstruction(new AllDecodersErrorTest.SubtractionDecoder(child_1));
							child_1.end();
						}
					}
				}
				if(type == 2) {
					ExpressionPeer.Indirect indirect_2 = peer_.getExpressionForValue();
					if(indirect_2 != null) {
						ExpressionPeer.MultiplicationPatternPeer child_2 = indirect_2.createMultiplication();
						if(child_2 != null) {
							element.updateConstruction(new AllDecodersErrorTest.MultiplicationDecoder(child_2));
							child_2.end();
						}
					}
				}
				if(type == 3) {
					ExpressionPeer.Indirect indirect_3 = peer_.getExpressionForValue();
					if(indirect_3 != null) {
						ExpressionPeer.DivisionPatternPeer child_3 = indirect_3.createDivision();
						if(child_3 != null) {
							element.updateConstruction(new AllDecodersErrorTest.DivisionDecoder(child_3));
							child_3.end();
						}
					}
				}
				if(type == 4) {
					ExpressionPeer.Indirect indirect_4 = peer_.getExpressionForValue();
					if(indirect_4 != null) {
						org.ffd2.austenx.runtime.BaseToken nameToken = element.getBaseArgumentToken(0);
						ExpressionPeer.FunctionPatternPeer child_4 = indirect_4.createFunction(nameToken.getStringValue());
						if(child_4 != null) {
							element.updateConstruction(new AllDecodersErrorTest.FunctionDecoder(child_4));
							child_4.end();
						}
					}
				}
				if(type == 5) {
					ExpressionPeer.Indirect indirect_5 = peer_.getExpressionForValue();
					if(indirect_5 != null) {
						org.ffd2.austenx.runtime.BaseToken nameToken_1 = element.getBaseArgumentToken(0);
						indirect_5.createVariable(nameToken_1.getStringValue());
					}
				}
				if(type == 6) {
					ExpressionPeer.Indirect indirect_6 = peer_.getExpressionForValue();
					if(indirect_6 != null) {
						ExpressionPeer.PrimitivePatternPeer child_5 = indirect_6.createPrimitive();
						if(child_5 != null) {
							element.updateConstruction(new AllDecodersErrorTest.PrimitiveDecoder(child_5));
							child_5.end();
						}
					}
				}
			}
		}
	}
	public static final class PrimitiveDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final ExpressionPeer.PrimitivePatternPeer peer_;
		public PrimitiveDecoder(ExpressionPeer.PrimitivePatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
			if(index == 0) {
				peer_.addNumber(token.getIntValue());
			}
			if(index == 1) {
				peer_.addBool(token.getBooleanValue());
			}
			if(index == 2) {
				peer_.addString(token.getStringValue());
			}
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
		}
	}
	public static final class FileDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final FilePatternPeer peer_;
		public FileDecoder(FilePatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				org.ffd2.austenx.runtime.BaseToken keywordToken = element.getBaseArgumentToken(0);
				org.ffd2.austenx.runtime.BaseToken nameToken = element.getBaseArgumentToken(1);
				FunctionDefPatternPeer child = peer_.addFunctionDefForFunctionBlock(keywordToken.getLineNumber(), keywordToken.getCharacterNumber(), nameToken.getStringValue());
				if(child != null) {
					element.updateConstruction(new AllDecodersErrorTest.FunctionDefDecoder(child));
					child.end();
				}
			}
		}
	}
	public static final class FunctionDefDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final FunctionDefPatternPeer peer_;
		public FunctionDefDecoder(FunctionDefPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
			if(index == 0) {
				peer_.markParameterError(markToken);
			}
			if(index == 1) {
				peer_.markMissingRightRoundError(markToken);
			}
			if(index == 2) {
				peer_.markError(markToken);
			}
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
			if(index == 2) {
				peer_.addP(token.getStringValue());
			}
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				int type = element.getType();
				if(type == 0) {
					StatementPeer.Indirect indirect = peer_.getStatementForStatements();
					if(indirect != null) {
						org.ffd2.austenx.runtime.BaseToken variableToken = element.getBaseArgumentToken(0);
						StatementPeer.AssignmentPatternPeer child = indirect.createAssignment(variableToken.getStringValue());
						if(child != null) {
							element.updateConstruction(new AllDecodersErrorTest.AssignmentDecoder(child));
							child.end();
						}
					}
				}
				if(type == 1) {
					StatementPeer.Indirect indirect_1 = peer_.getStatementForStatements();
					if(indirect_1 != null) {
						StatementPeer.BlockPatternPeer child_1 = indirect_1.createBlock();
						if(child_1 != null) {
							element.updateConstruction(new AllDecodersErrorTest.BlockDecoder(child_1));
							child_1.end();
						}
					}
				}
				if(type == 2) {
					StatementPeer.Indirect indirect_2 = peer_.getStatementForStatements();
					if(indirect_2 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken = element.getBaseArgumentToken(0);
						StatementPeer.IfPatternPeer child_2 = indirect_2.createIf(keywordToken.getLineNumber(), keywordToken.getCharacterNumber());
						if(child_2 != null) {
							element.updateConstruction(new AllDecodersErrorTest.IfDecoder(child_2));
							child_2.end();
						}
					}
				}
				if(type == 3) {
					StatementPeer.Indirect indirect_3 = peer_.getStatementForStatements();
					if(indirect_3 != null) {
						StatementPeer.ExpressionPatternPeer child_3 = indirect_3.createExpression();
						if(child_3 != null) {
							element.updateConstruction(new AllDecodersErrorTest.ExpressionDecoder(child_3));
							child_3.end();
						}
					}
				}
				if(type == 4) {
					StatementPeer.Indirect indirect_4 = peer_.getStatementForStatements();
					if(indirect_4 != null) {
						org.ffd2.austenx.runtime.BaseToken lastSemicolonToken = element.getBaseArgumentToken(0);
						org.ffd2.austenx.runtime.BaseToken markToken = element.getMarkToken(0);
						indirect_4.createError(markToken, lastSemicolonToken.getLineNumber(), lastSemicolonToken.getCharacterNumber());
					}
				}
			}
		}
	}
	public static final class AssignmentDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final StatementPeer.AssignmentPatternPeer peer_;
		public AssignmentDecoder(StatementPeer.AssignmentPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				int type = element.getType();
				if(type == 0) {
					ExpressionPeer.Indirect indirect = peer_.getExpressionForValue();
					if(indirect != null) {
						ExpressionPeer.AdditionPatternPeer child = indirect.createAddition();
						if(child != null) {
							element.updateConstruction(new AllDecodersErrorTest.AdditionDecoder(child));
							child.end();
						}
					}
				}
				if(type == 1) {
					ExpressionPeer.Indirect indirect_1 = peer_.getExpressionForValue();
					if(indirect_1 != null) {
						ExpressionPeer.SubtractionPatternPeer child_1 = indirect_1.createSubtraction();
						if(child_1 != null) {
							element.updateConstruction(new AllDecodersErrorTest.SubtractionDecoder(child_1));
							child_1.end();
						}
					}
				}
				if(type == 2) {
					ExpressionPeer.Indirect indirect_2 = peer_.getExpressionForValue();
					if(indirect_2 != null) {
						ExpressionPeer.MultiplicationPatternPeer child_2 = indirect_2.createMultiplication();
						if(child_2 != null) {
							element.updateConstruction(new AllDecodersErrorTest.MultiplicationDecoder(child_2));
							child_2.end();
						}
					}
				}
				if(type == 3) {
					ExpressionPeer.Indirect indirect_3 = peer_.getExpressionForValue();
					if(indirect_3 != null) {
						ExpressionPeer.DivisionPatternPeer child_3 = indirect_3.createDivision();
						if(child_3 != null) {
							element.updateConstruction(new AllDecodersErrorTest.DivisionDecoder(child_3));
							child_3.end();
						}
					}
				}
				if(type == 4) {
					ExpressionPeer.Indirect indirect_4 = peer_.getExpressionForValue();
					if(indirect_4 != null) {
						org.ffd2.austenx.runtime.BaseToken nameToken = element.getBaseArgumentToken(0);
						ExpressionPeer.FunctionPatternPeer child_4 = indirect_4.createFunction(nameToken.getStringValue());
						if(child_4 != null) {
							element.updateConstruction(new AllDecodersErrorTest.FunctionDecoder(child_4));
							child_4.end();
						}
					}
				}
				if(type == 5) {
					ExpressionPeer.Indirect indirect_5 = peer_.getExpressionForValue();
					if(indirect_5 != null) {
						org.ffd2.austenx.runtime.BaseToken nameToken_1 = element.getBaseArgumentToken(0);
						indirect_5.createVariable(nameToken_1.getStringValue());
					}
				}
				if(type == 6) {
					ExpressionPeer.Indirect indirect_6 = peer_.getExpressionForValue();
					if(indirect_6 != null) {
						ExpressionPeer.PrimitivePatternPeer child_5 = indirect_6.createPrimitive();
						if(child_5 != null) {
							element.updateConstruction(new AllDecodersErrorTest.PrimitiveDecoder(child_5));
							child_5.end();
						}
					}
				}
			}
		}
	}
	public static final class BlockDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final StatementPeer.BlockPatternPeer peer_;
		public BlockDecoder(StatementPeer.BlockPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				int type = element.getType();
				if(type == 0) {
					StatementPeer.Indirect indirect = peer_.getStatementForStatement();
					if(indirect != null) {
						org.ffd2.austenx.runtime.BaseToken variableToken = element.getBaseArgumentToken(0);
						StatementPeer.AssignmentPatternPeer child = indirect.createAssignment(variableToken.getStringValue());
						if(child != null) {
							element.updateConstruction(new AllDecodersErrorTest.AssignmentDecoder(child));
							child.end();
						}
					}
				}
				if(type == 1) {
					StatementPeer.Indirect indirect_1 = peer_.getStatementForStatement();
					if(indirect_1 != null) {
						StatementPeer.BlockPatternPeer child_1 = indirect_1.createBlock();
						if(child_1 != null) {
							element.updateConstruction(new AllDecodersErrorTest.BlockDecoder(child_1));
							child_1.end();
						}
					}
				}
				if(type == 2) {
					StatementPeer.Indirect indirect_2 = peer_.getStatementForStatement();
					if(indirect_2 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken = element.getBaseArgumentToken(0);
						StatementPeer.IfPatternPeer child_2 = indirect_2.createIf(keywordToken.getLineNumber(), keywordToken.getCharacterNumber());
						if(child_2 != null) {
							element.updateConstruction(new AllDecodersErrorTest.IfDecoder(child_2));
							child_2.end();
						}
					}
				}
				if(type == 3) {
					StatementPeer.Indirect indirect_3 = peer_.getStatementForStatement();
					if(indirect_3 != null) {
						StatementPeer.ExpressionPatternPeer child_3 = indirect_3.createExpression();
						if(child_3 != null) {
							element.updateConstruction(new AllDecodersErrorTest.ExpressionDecoder(child_3));
							child_3.end();
						}
					}
				}
				if(type == 4) {
					StatementPeer.Indirect indirect_4 = peer_.getStatementForStatement();
					if(indirect_4 != null) {
						org.ffd2.austenx.runtime.BaseToken lastSemicolonToken = element.getBaseArgumentToken(0);
						org.ffd2.austenx.runtime.BaseToken markToken = element.getMarkToken(0);
						indirect_4.createError(markToken, lastSemicolonToken.getLineNumber(), lastSemicolonToken.getCharacterNumber());
					}
				}
			}
		}
	}
	public static final class IfDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final StatementPeer.IfPatternPeer peer_;
		public IfDecoder(StatementPeer.IfPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				int type = element.getType();
				if(type == 0) {
					ExpressionPeer.Indirect indirect = peer_.getExpressionForConditional();
					if(indirect != null) {
						ExpressionPeer.AdditionPatternPeer child = indirect.createAddition();
						if(child != null) {
							element.updateConstruction(new AllDecodersErrorTest.AdditionDecoder(child));
							child.end();
						}
					}
				}
				if(type == 1) {
					ExpressionPeer.Indirect indirect_1 = peer_.getExpressionForConditional();
					if(indirect_1 != null) {
						ExpressionPeer.SubtractionPatternPeer child_1 = indirect_1.createSubtraction();
						if(child_1 != null) {
							element.updateConstruction(new AllDecodersErrorTest.SubtractionDecoder(child_1));
							child_1.end();
						}
					}
				}
				if(type == 2) {
					ExpressionPeer.Indirect indirect_2 = peer_.getExpressionForConditional();
					if(indirect_2 != null) {
						ExpressionPeer.MultiplicationPatternPeer child_2 = indirect_2.createMultiplication();
						if(child_2 != null) {
							element.updateConstruction(new AllDecodersErrorTest.MultiplicationDecoder(child_2));
							child_2.end();
						}
					}
				}
				if(type == 3) {
					ExpressionPeer.Indirect indirect_3 = peer_.getExpressionForConditional();
					if(indirect_3 != null) {
						ExpressionPeer.DivisionPatternPeer child_3 = indirect_3.createDivision();
						if(child_3 != null) {
							element.updateConstruction(new AllDecodersErrorTest.DivisionDecoder(child_3));
							child_3.end();
						}
					}
				}
				if(type == 4) {
					ExpressionPeer.Indirect indirect_4 = peer_.getExpressionForConditional();
					if(indirect_4 != null) {
						org.ffd2.austenx.runtime.BaseToken nameToken = element.getBaseArgumentToken(0);
						ExpressionPeer.FunctionPatternPeer child_4 = indirect_4.createFunction(nameToken.getStringValue());
						if(child_4 != null) {
							element.updateConstruction(new AllDecodersErrorTest.FunctionDecoder(child_4));
							child_4.end();
						}
					}
				}
				if(type == 5) {
					ExpressionPeer.Indirect indirect_5 = peer_.getExpressionForConditional();
					if(indirect_5 != null) {
						org.ffd2.austenx.runtime.BaseToken nameToken_1 = element.getBaseArgumentToken(0);
						indirect_5.createVariable(nameToken_1.getStringValue());
					}
				}
				if(type == 6) {
					ExpressionPeer.Indirect indirect_6 = peer_.getExpressionForConditional();
					if(indirect_6 != null) {
						ExpressionPeer.PrimitivePatternPeer child_5 = indirect_6.createPrimitive();
						if(child_5 != null) {
							element.updateConstruction(new AllDecodersErrorTest.PrimitiveDecoder(child_5));
							child_5.end();
						}
					}
				}
			}
			if(index == 1) {
				int type_1 = element.getType();
				if(type_1 == 0) {
					StatementPeer.Indirect indirect_7 = peer_.getStatementForTrueStatement();
					if(indirect_7 != null) {
						org.ffd2.austenx.runtime.BaseToken variableToken = element.getBaseArgumentToken(0);
						StatementPeer.AssignmentPatternPeer child_6 = indirect_7.createAssignment(variableToken.getStringValue());
						if(child_6 != null) {
							element.updateConstruction(new AllDecodersErrorTest.AssignmentDecoder(child_6));
							child_6.end();
						}
					}
				}
				if(type_1 == 1) {
					StatementPeer.Indirect indirect_8 = peer_.getStatementForTrueStatement();
					if(indirect_8 != null) {
						StatementPeer.BlockPatternPeer child_7 = indirect_8.createBlock();
						if(child_7 != null) {
							element.updateConstruction(new AllDecodersErrorTest.BlockDecoder(child_7));
							child_7.end();
						}
					}
				}
				if(type_1 == 2) {
					StatementPeer.Indirect indirect_9 = peer_.getStatementForTrueStatement();
					if(indirect_9 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken = element.getBaseArgumentToken(0);
						StatementPeer.IfPatternPeer child_8 = indirect_9.createIf(keywordToken.getLineNumber(), keywordToken.getCharacterNumber());
						if(child_8 != null) {
							element.updateConstruction(new AllDecodersErrorTest.IfDecoder(child_8));
							child_8.end();
						}
					}
				}
				if(type_1 == 3) {
					StatementPeer.Indirect indirect_10 = peer_.getStatementForTrueStatement();
					if(indirect_10 != null) {
						StatementPeer.ExpressionPatternPeer child_9 = indirect_10.createExpression();
						if(child_9 != null) {
							element.updateConstruction(new AllDecodersErrorTest.ExpressionDecoder(child_9));
							child_9.end();
						}
					}
				}
				if(type_1 == 4) {
					StatementPeer.Indirect indirect_11 = peer_.getStatementForTrueStatement();
					if(indirect_11 != null) {
						org.ffd2.austenx.runtime.BaseToken lastSemicolonToken = element.getBaseArgumentToken(0);
						org.ffd2.austenx.runtime.BaseToken markToken = element.getMarkToken(0);
						indirect_11.createError(markToken, lastSemicolonToken.getLineNumber(), lastSemicolonToken.getCharacterNumber());
					}
				}
			}
			if(index == 2) {
				int type_2 = element.getType();
				if(type_2 == 0) {
					StatementPeer.Indirect indirect_12 = peer_.getStatementForFalseStatement();
					if(indirect_12 != null) {
						org.ffd2.austenx.runtime.BaseToken variableToken_1 = element.getBaseArgumentToken(0);
						StatementPeer.AssignmentPatternPeer child_10 = indirect_12.createAssignment(variableToken_1.getStringValue());
						if(child_10 != null) {
							element.updateConstruction(new AllDecodersErrorTest.AssignmentDecoder(child_10));
							child_10.end();
						}
					}
				}
				if(type_2 == 1) {
					StatementPeer.Indirect indirect_13 = peer_.getStatementForFalseStatement();
					if(indirect_13 != null) {
						StatementPeer.BlockPatternPeer child_11 = indirect_13.createBlock();
						if(child_11 != null) {
							element.updateConstruction(new AllDecodersErrorTest.BlockDecoder(child_11));
							child_11.end();
						}
					}
				}
				if(type_2 == 2) {
					StatementPeer.Indirect indirect_14 = peer_.getStatementForFalseStatement();
					if(indirect_14 != null) {
						org.ffd2.austenx.runtime.BaseToken keywordToken_1 = element.getBaseArgumentToken(0);
						StatementPeer.IfPatternPeer child_12 = indirect_14.createIf(keywordToken_1.getLineNumber(), keywordToken_1.getCharacterNumber());
						if(child_12 != null) {
							element.updateConstruction(new AllDecodersErrorTest.IfDecoder(child_12));
							child_12.end();
						}
					}
				}
				if(type_2 == 3) {
					StatementPeer.Indirect indirect_15 = peer_.getStatementForFalseStatement();
					if(indirect_15 != null) {
						StatementPeer.ExpressionPatternPeer child_13 = indirect_15.createExpression();
						if(child_13 != null) {
							element.updateConstruction(new AllDecodersErrorTest.ExpressionDecoder(child_13));
							child_13.end();
						}
					}
				}
				if(type_2 == 4) {
					StatementPeer.Indirect indirect_16 = peer_.getStatementForFalseStatement();
					if(indirect_16 != null) {
						org.ffd2.austenx.runtime.BaseToken lastSemicolonToken_1 = element.getBaseArgumentToken(0);
						org.ffd2.austenx.runtime.BaseToken markToken_1 = element.getMarkToken(0);
						indirect_16.createError(markToken_1, lastSemicolonToken_1.getLineNumber(), lastSemicolonToken_1.getCharacterNumber());
					}
				}
			}
		}
	}
	public static final class ExpressionDecoder implements org.ffd2.austenx.runtime.NodeConstruction {
		private final StatementPeer.ExpressionPatternPeer peer_;
		public ExpressionDecoder(StatementPeer.ExpressionPatternPeer peer) {
			peer_ = peer;
		}
		public final void addExtraInt(int index, int value) {
		}
		public final void addExtraError(int index, org.ffd2.austenx.runtime.ErrorInfo error) {
		}
		public final void addExtraMark(int index, org.ffd2.austenx.runtime.BaseToken markToken) {
		}
		public final void addExtraBoolean(int index, boolean value) {
		}
		public final void addExtraString(int index, java.lang.String value) {
		}
		public final void addSubToken(int index, org.ffd2.austenx.runtime.BaseToken token) {
		}
		public final void addSubNode(int index, org.ffd2.austenx.runtime.ResolvedPackratElement element) {
			if(index == 0) {
				int type = element.getType();
				if(type == 0) {
					ExpressionPeer.Indirect indirect = peer_.getExpressionForE();
					if(indirect != null) {
						ExpressionPeer.AdditionPatternPeer child = indirect.createAddition();
						if(child != null) {
							element.updateConstruction(new AllDecodersErrorTest.AdditionDecoder(child));
							child.end();
						}
					}
				}
				if(type == 1) {
					ExpressionPeer.Indirect indirect_1 = peer_.getExpressionForE();
					if(indirect_1 != null) {
						ExpressionPeer.SubtractionPatternPeer child_1 = indirect_1.createSubtraction();
						if(child_1 != null) {
							element.updateConstruction(new AllDecodersErrorTest.SubtractionDecoder(child_1));
							child_1.end();
						}
					}
				}
				if(type == 2) {
					ExpressionPeer.Indirect indirect_2 = peer_.getExpressionForE();
					if(indirect_2 != null) {
						ExpressionPeer.MultiplicationPatternPeer child_2 = indirect_2.createMultiplication();
						if(child_2 != null) {
							element.updateConstruction(new AllDecodersErrorTest.MultiplicationDecoder(child_2));
							child_2.end();
						}
					}
				}
				if(type == 3) {
					ExpressionPeer.Indirect indirect_3 = peer_.getExpressionForE();
					if(indirect_3 != null) {
						ExpressionPeer.DivisionPatternPeer child_3 = indirect_3.createDivision();
						if(child_3 != null) {
							element.updateConstruction(new AllDecodersErrorTest.DivisionDecoder(child_3));
							child_3.end();
						}
					}
				}
				if(type == 4) {
					ExpressionPeer.Indirect indirect_4 = peer_.getExpressionForE();
					if(indirect_4 != null) {
						org.ffd2.austenx.runtime.BaseToken nameToken = element.getBaseArgumentToken(0);
						ExpressionPeer.FunctionPatternPeer child_4 = indirect_4.createFunction(nameToken.getStringValue());
						if(child_4 != null) {
							element.updateConstruction(new AllDecodersErrorTest.FunctionDecoder(child_4));
							child_4.end();
						}
					}
				}
				if(type == 5) {
					ExpressionPeer.Indirect indirect_5 = peer_.getExpressionForE();
					if(indirect_5 != null) {
						org.ffd2.austenx.runtime.BaseToken nameToken_1 = element.getBaseArgumentToken(0);
						indirect_5.createVariable(nameToken_1.getStringValue());
					}
				}
				if(type == 6) {
					ExpressionPeer.Indirect indirect_6 = peer_.getExpressionForE();
					if(indirect_6 != null) {
						ExpressionPeer.PrimitivePatternPeer child_5 = indirect_6.createPrimitive();
						if(child_5 != null) {
							element.updateConstruction(new AllDecodersErrorTest.PrimitiveDecoder(child_5));
							child_5.end();
						}
					}
				}
			}
		}
	}
}
