package indent.austen.packrat.impl;
import indent.austen.packrat.library.*;
import indent.austen.user.*;
import indent.austen.lexi.tokens.*;
public final class ClassReader implements IndentTestPackrat.BaseReader {
	private final int rULE_INDEX_ = 3;
	private final IndentTestPackrat basePackrat_;
	public ClassReader(IndentTestPackrat basePackrat) {
		basePackrat_ = basePackrat;
	}
	public final org.ffd2.austenx.runtime.PackratElement build(IndentTestPackrat.Column c, org.ffd2.austenx.runtime.PackratElement oldElement) {
		org.ffd2.austenx.runtime.ResolvedPackratElement result = new org.ffd2.austenx.runtime.ResolvedPackratElement();
		int width = decodeClass(result, c, 0);
		if(width > 0) {
			result.setDetails(width, 0, 3);
			return oldElement.getImprovedByOrNull(result);
		}
		return null;
	}
	public final int decodeClass(org.ffd2.austenx.runtime.ResolvedPackratElement result, IndentTestPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		c.indentBaseValue_ = 0;
		c.currentIndentValue_ = 0;
		IndentTrackerUser baseClass = basePackrat_.trackerValue_;
		int lineInt;
		lineInt = c.getCurrentLineNumber(newOffset);
		c.indentBaseValue_ = baseClass.getIndent(lineInt);
		IndentToken token = c.getColumnToken(newOffset);
		if(!token.isCLASS_KEYWORD()) {
			return -1;
		}
		newOffset++;
		result.addBaseArgument(0, token);
		IndentToken token_1 = c.getColumnToken(newOffset);
		if(!token_1.isID()) {
			return -1;
		}
		newOffset++;
		result.addBaseArgument(1, token_1);
		int checkOffset = newOffset;
		result.mark();
		while(checkOffset >= 0) {
			checkOffset = zeroOrMoreSub(result, c, newOffset);
			if(checkOffset > newOffset) {
				newOffset = checkOffset;
				result.bumpLastMark();
			} else {
				result.undoToMark();
			}
		}
		return newOffset;
	}
	public final int zeroOrMoreSub(org.ffd2.austenx.runtime.ResolvedPackratElement result, IndentTestPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		IndentTrackerUser baseClass = basePackrat_.trackerValue_;
		int lineInt;
		lineInt = c.getCurrentLineNumber(newOffset);
		c.currentIndentValue_ = baseClass.getIndent(lineInt);
		boolean passQuery;
		int left;
		int right;
		left = c.indentBaseValue_;
		right = c.currentIndentValue_;
		passQuery = left < right;
		if(!passQuery) {
			return -1;
		}
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 5).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(0, rule);
		return newOffset;
	}
}
