package indent.austen.peg.base;
public final class ExpressionPeer {
	public static interface Indirect {
		public ExpressionPeer.FunctionPatternPeer createFunction(java.lang.String name) ;
		public void createVariable(java.lang.String name) ;
		public ExpressionPeer.PrimitivePatternPeer createPrimitive() ;
	}
	public static interface FunctionPatternPeer {
		public void end() ;
		public ExpressionPeer.Indirect getExpressionForValue() ;
	}
	public static interface PrimitivePatternPeer {
		public void end() ;
		public void addNumber(int value) ;
		public void addBool(boolean value) ;
		public void addString(java.lang.String value) ;
	}
}
