package indent.austen.peg.base;
public final class StatementPeer {
	public static interface Indirect {
		public StatementPeer.AssignmentPatternPeer createAssignment(java.lang.String variable) ;
		public StatementPeer.IfPatternPeer createIf(int keywordLine, int keywordCharacter) ;
		public StatementPeer.ExpressionPatternPeer createExpression() ;
	}
	public static interface AssignmentPatternPeer {
		public void end() ;
		public ExpressionPeer.Indirect getExpressionForValue() ;
	}
	public static interface IfPatternPeer {
		public void end() ;
		public ExpressionPeer.Indirect getExpressionForConditional() ;
		public StatementPeer.Indirect getStatementForStatements() ;
		public StatementPeer.Indirect getStatementForElseStatements() ;
	}
	public static interface ExpressionPatternPeer {
		public void end() ;
		public ExpressionPeer.Indirect getExpressionForE() ;
	}
}
